string __version = "0.1";
string __author = "Bertrand LUPART <bertrand@caudium.net>";
array __components = ({ "Public.pmod/Standards.pmod/XML.pmod/module.pmod" });

constant NUMERIC_HEX = 1;


//! Encodes numerical entities. Default to dec.
//! > Public.Standards.XML.encode_numeric_entity("pike");
//! (1) Result: "&#112;&#105;&#107;&#101;"
//! > Public.Standards.XML.encode_numeric_entity("pike", Public.Standards.XML.NUMERIC_HEX);
//! (2) Result: "&#x70;&#x69;&#x6b;&#x65;"
//!
//! @param from
//! The string to be encoded
//!
//! @returns
//! The encoded string
string encode_numeric_entity(string from, void|int type)
{
	if(type && intp(type) && type==NUMERIC_HEX)
		return encode_numeric_entity_hex(from);
	return encode_numeric_entity_dec(from);
}


//! Encodes numerical entities to hex.
//! > Public.Standards.XML.encode_numeric_entity_hex("pike");
//! (1) Result: "&#x70;&#x69;&#x6b;&#x65;"
//!
//! @param from
//! The string to be encoded
//!
//! @returns
//! The encoded string.
string encode_numeric_entity_hex(string from)
{
  string to = "";
  foreach(from; int index; string value)
    to+=sprintf("&#x%x;", value);
  return to;
}


//! Encodes numerical entities to dec.
//! > Public.Standards.XML.encode_numeric_entity_dec("pike");
//! (1) Result: "&#112;&#105;&#107;&#101;"
//!
//! @param from
//! The string to be encoded
//!
//! @returns
//! The encoded string.
string encode_numeric_entity_dec(string from)
{
  string to = "";
  foreach(from; int index; string value)
    to+=sprintf("&#%d;", value);
  return to;
}
